UNIT ClassicKi;

INTERFACE

uses
  ClassicDecla;

procedure inverse8(var na,nb: ar_w);
	{ entre: na; sortie: nb         }
	{ na*nb = 1 modulo (2exp127 - 1) }

IMPLEMENTATION

uses
  ClassicMath7, ClassicCalcul8;

procedure inverse(var na,nb: ar_2w); forward;
	{ entre: na, lga; sortie: nb, lgb }
	{ na*nb=1 modulo (2exp127 - 1)	   }

{------------------------------------------------------------------------------}

PROCEDURE inverse8(var na,nb: ar_w);
	{ entre: na, lga; sortie: nb, lgb				}
	{ na est d'abord rduit  127 bits				}
	{ ensuite on calcule nb tel que na*nb=1 modulo (2exp127 - 1)	}
	{ et finalement on ajoute  nb un bit 128 tel que               }
	{ nb obtienne la mme parit que celle qu'avait initialement na	}
var
  n2v,n2w: ar_2w;
  nv: ar_w absolute n2v;
  nw: ar_w absolute n2w;
  Pa: boolean;
begin
  vecteur8_7(na,nv,Pa);
  inverse(n2v,n2w);
  vecteur7_8(Pa,nw,nb);
  voiler(nv);
  voiler(nW);
end;

procedure inverse(var na,nb: ar_2w);
	{ entre: na, lga; sortie: nb, lgb		}
	{ na*nb = 1 modulo (2exp127 - 1)	       	}
	{ pratiquement on calcule			}
	{ nw = (na)exp(2exp127 - 2) modulo(2exp127 - 1) }
var
  nc: ar_2w;
  ncc: ar_w absolute nc;
  i: integer;
begin
  mam7(na,na,nb);
  for i:=1 to 124 do begin
    mam7(nb,na,nc);
    mam7(nc,nc,nb) end;
  mam7(nb,nb,nc);
  mam7(nc,na,nb);
  voiler(ncc);
end;

END.
