UNIT ClassicMath8;

INTERFACE

uses
  SysUtils, ClassicDecla;

Procedure EntreeH8(nbr: string; var nw: ar_w);
	{ entre: nbr (nombre en 32 caractres hexadcimaux) }
	{ sortie: nw (conversion de nbr en 128 bits)         }
function BinHex8(var nw: ar_w): string;
	{ sortie: chane de 32 caractres hexadcimaux }
procedure hasard8(var nV: ar_w);
         { sortie: nV (128 bits pseudo-alatoires) }

IMPLEMENTATION

uses
  ClassicMath;

PROCEDURE EntreeH8(nbr: string; var nw: ar_w);
	{ entre: nbr (nombre en 32 caractres hexadcimaux) }
	{ sortie: nw (conversion de nbr en 128 bits)         }
var
  lg: integer;
  i: integer;
begin
  EntreeH(nbr,nw,lg);
  for i:=lg+1 to 8 do nW[i]:=0;
end;

FUNCTION BinHex8(var nw: ar_w): string;
	{ sortie: chane de 32 caractres hexadcimaux }
begin
  result:=BinHex(nw,8);
end;

PROCEDURE hasard8(var nV: ar_w);
         { sortie: nV (128 bits pseudo-alatoires) }
begin
  hasard(nV,8);
end;

END.
